proc about
  cls : let x=10
  print tab x;"***                          dbf2htm                          ***"
  print tab x+29; ink 2;"-------"; ink 7
  print 
  print tab x;"Convert Archive databse files into html tables at the touch of a"
  print tab x+25;"button! (or two)"
  print 
  print tab x;"See the readme file for instructions. Type "; ink 4;"edit"; ink 7;" at the console"
  print tab x;"and "; ink 4;"tab"; ink 7;" your way to the procedure htmlise to alter the program"
  print tab x;"settings. Then type "; ink 4;"htmlise"; ink 7;" to start."
  print : print 
  print tab x+26;"Happy QL-ing!"
  print at 18,x+12;"version 0.03    pjwitte    April 21st 2oo1"
  endproc 
proc html;lfn$,fnm$,tit$
  local i,c
  rem Output database as html table
  rem pwitte March 3rd 2oo1
  rem V0.01 With translate of QL to htm chars
  rem V0.02 With suggestions by Peter S Tillier [PST]
  rem V0.03 First release version
  rem ***
  spoolon fnm$ dump 
  use lfn$: let tc=count()
  lprint "<html><header><title>";tit$;"</title></header><body>"
  lprint "<center><h1><font color=blue>";tit$;"</font></h1></center><br>"
  lprint "<table align=center border=1>"
  let i=0
  lprint "<tr>"
  while i<numfld()
    let v$=fieldn(i)
    rem Trim off "$" from the non-numeric variable name [PST]
    if fieldt(i)=1: let v$=v$(1 to len(v$)-1): endif 
    tran;v$: use lfn$:rem Translate charset
    lprint "<th align=center><h3>";v$;"</h3></th>";
    let i=i+1
    endwhile 
  lprint "</tr><tr>"
  first : let c=0
  while not eof()
    let i=0: let c=c+1
    print at 6,12;tc;"/";c;
    while i<numfld()
      if fieldt(i)=1
        let v$=fieldv(i)
        if len(v$)=0
          let v$="&nbsp;"
          else 
          tran;v$: use lfn$:rem Translate charset
          endif 
        lprint "<td>";v$;"</td>";
        else 
        rem print numerics right aligned [PST]
        lprint "<td align=right>";fieldv(i);"</td>";
        rem You could also add code to
        rem   highlight negative values,
        rem   replace 0 with "-",
        rem   number formatting, currency symbol, etc
        endif 
      let i=i+1
      endwhile 
    lprint "</tr>"
    next 
    endwhile 
  lprint "</table>"
  lprint "</body></html>"
  spooloff 
  endproc 
proc htmlise
  rem        Harness for dbf2htm
  cls : print "---       Htlm-ising       ---": print 
  rem *** - - - - - - - - - - - - - - - - - - - - - - - - - - ***
  rem Alter Title, Input and Output file names:
  let title$="Third World 1983":rem At a guess
  let fnminp$="win2_data_Gazet_dbf"
  let fnmout$="ram1_Gazet_htm"
  rem *** - - - - - - - - - - - - - - - - - - - - - - - - - - ***
  rem Alter block for pre-prepared database file
  print "Preparing data file "+fnminp$+".."
  let lfnm$="d2b"
  look fnminp$ logical lfnm$
  rem Select, sort, etc here, if required
  select (gdp/pop)<5: order pop;d,country$;a
  rem *** - - - - - - - - - - - - - - - - - - - - - - - - - - ***
  rem        Choose one of the target charsets below:
  rem PC - only real option at present
  look "win2_psion_html_htmpc_dbf" logical "html"
  rem look datad$+"htmqlx_dbf" logical "html"
  rem look datad$+"htmpws_dbf" logical "html"
  rem *** - - - - - - - - - - - - - - - - - - - - - - - - - - ***
  print "Exporting to "+fnmout$+".."
  html;lfnm$,fnmout$,title$
  close "html"
  use lfnm$: reset 
  close lfnm$
  print at 8,0;"Done!"
  endproc 
proc info
  about
  endproc 
proc start
  about
  endproc 
proc sv
  spoolon "win1_prg_psion_html_d2h003_prg" dump 
  llist 
  spooloff 
  print "Saved Ok"
  endproc 
proc tran;str$
  local i,c
  rem Translate QL-string to html-string
  rem using lookup table
  rem Archive and the IOSS may do horrible
  rem things to your string afterwards, though!
  use "html":rem Remember to 'use "lfnm"' on return!
  let i=1: let v$="":rem Replace global v$
  while i<=len(str$)
    position code(str$(i))
    if htm$(1)="%"
      rem Certain characters arent acceptable in dbf
      let v$=v$+chr(val(htm$(2 to len(htm$))))
      else 
      let v$=v$+htm$
      endif 
    let i=i+1
    endwhile 
  return v$
  endproc 
